/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "../headers/RNA_structure.h"
#include "../headers/stack.h"
#include "../headers/graph.h"
#ifndef ALIGN_GRAPH_H_
#define ALIGN_GRAPH_H_
#define ABCD "1111"
#define ACD "1011"
#define ABD "1101"
#define AB "1100"
#define B "0100"
#define C "0010"
#define D "0001"

char ** constraint; 
int *** table;
vertex_gap ** alignment_graph;
int * full_deletionA;
int * full_deletionB;
char ** is_closedA;
char ** is_closedB; 

int best_table(int x, int y, char* table_list); 
int get_tables(int z, int x, int y, char* table_list); 
void computeTables(postorder_tree * treeA, postorder_tree * treeB,int i,int j, int k, int l);
void computeTables_Cell(postorder_tree * treeA, postorder_tree * treeB,int x,int y, int i,int j);
void build_alignment_graph(postorder_tree * treeA, postorder_tree * treeB);
void build_optimal_path(postorder_tree * treeA,postorder_tree * treeB,int i,int j,int k,int l,int source_table ,int positionA,int positionB,seven_stack * p,int ** supertree);

#endif /* ALIGN_GRAPH_H */
