/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "../headers/RNA_multiple_structure.h"

#ifndef __CLUSTERING_H__
#define __CLUSTERING_H__

/* definition of a cluster 
 * left and right are the nodes which were merged to build 
 * the current cluster
 * their value is -1 when the cluster is a leaf
 */
typedef struct{
  int left;
  int right;
  int diametre;
  int *seq;
  int nbre_seq;
}cluster;


void display_tab(int **tab, int nb_seq);
void display_cluster(cluster **tab, int nb_seq);

void perform_clustering(cluster **liste_cluster, int **similarite, int nbre_clusters);

/*
 * similarity: score matrix
 * nb_seq:     number of sequences to align
 * list:       list of sequences to align
 * sc:         will contain the score of the alignment
 *
 * RETURN: the alignment
 */
RNA_sequence_m *clustering(int **similarity, int nb_seq, RNA_sequence_m **list, int *sc, int EQ, int SIMILAR);

#endif
