/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "types.h"
#include "find_blocks.h"
#include "RNA_structure.h"
#include "RNA_multiple_structure.h"
#ifndef CONSTRAINT_H_
#define CONSTRAINT_H_

#define    ALLOWED       0
#define    FORBIDDEN     1

typedef struct{
  char num;
  int begin;
  int end;
}square_t;

/*initialise la matrices de contraintes*/
void no_constraint(char ** cons,int m, int n);

void display_constraint(char ** cons, int m, int n);

void full_constraint(char **cons, int m, int n);

void diagonal_constraint(char ** cons, int m, int n, int d);

/*prend deux squences, les aligne, recupre les blocs aligns et les ajoute dans la matrice des contraintes*/
void primary_sequence_constraint(char ** cons, postorder_tree * treeA, postorder_tree * treeB, RNA_sequence *rnaA,RNA_sequence *rnaB); 
 
void eq_constraint(char **cons, postorder_tree_m *treeA, postorder_tree_m *treeB,
		   char *eqA, char *eqB, int eqA_size, int eqB_size, int multiple);


#endif /*CONSTRAINT_H_*/
