/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "RNA_structure.h"

#ifndef EDIT_DISTANCE_H_
#define EDIT_DISTANCE_H_

/* compute the value of the optimal edit distance between  rnaA and rnaB 
 */ 
int optimal_edit_score( RNA_sequence *rnaA, RNA_sequence *rnaB, int primary, int similar,  int full_edit, int eq, char *eqA, char *eqB); 

/* compute the value and the mapping of the optimal edit distance between  rnaA and rnaB 
 */
int optimal_edit_mapping(RNA_sequence* rnaA, RNA_sequence* rnaB, int primary, int similar, char* nameCtA, char * nameCtB, char * nameFileOut, 
		    RNA_sequence* alignA, RNA_sequence* alignB, int full_edit, int eq, char *eqA, char *eqB); 

#endif /*EDIT_DISTANCE_H_*/
