/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#ifndef GRAPH_H_
#define GRAPH_H_



/**********************************/
/* GRAPH STRUCTURES AND FUNCTIONS */
/**********************************/

typedef struct{
  int weight;
  short int targetX;
  short int targetY;
  char edit_operation; /*-1 pour del, 1 pour ins et 0 pour match */
}edge;


typedef struct{
  edge * elements;
  short int current_edge;
}vertex;

void update_edge(vertex *v, edge x);

/*Empile un lment  la pile*/
void push_edge(vertex * v, edge x);

/*Dpile un lment a la pile*/
void get_edge(vertex * v, edge * x, int d);

/*Teste si la pile est vide*/
int end_of_edge_stack(vertex * v);

/*Initialise la pile*/
void init_edge_stack(vertex  * v, int size);

void display_alignment_graph(vertex ** alignment_graph, int k, int l);



/**********************************************************/
/* GRAPH STRUCTURES AND FUNCTIONS FOR ALGORITHM WITH GAPS */
/**********************************************************/

typedef struct{
  int weight;
  short int targetX;
  short int targetY;
  char edit_operation; 
  char origin; /* etat precedent*/ 
  char table; /* numero de la table */
}edge_gap;


typedef struct{
  edge_gap * elements; 
  short int current_edge;
}vertex_gap;


void update(int w, char eo, edge * ed); 

void update_edge_gap(vertex_gap *v, edge_gap x,  int * nee);

/*Empile un lment  la pile*/
void push_edge_gap(vertex_gap * v, edge_gap x);

/*Dpile un lment a la pile*/
void get_edge_gap( vertex_gap * v, edge_gap * x, int d);

/*Teste si la pile est vide*/
int end_of_edge_stack_gap(vertex_gap * v);

/*Initialise la pile*/
void init_edge_stack_gap(vertex_gap  * v, int size);

void display_alignment_graph_gap(vertex_gap ** alignment_graph, int k, int l);

#endif /*GRAPH_H_*/
