/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "RNA_structure.h"
#ifndef SCORE_H_
#define SCORE_H_
#define PAIRED_SIZE     16  
#define UNPAIRED_SIZE    4
#define ID 1
#define DEL -10
#define INS -10
#define BASE_MATCH 2
#define BASE_MISMATCH -1
#define HYDROGEN_MATCH 1
#define ARC_MATCH 2
#define ARC_MISMATCH -1 
#define SUB 0
#define sub_leaf_node -10000
#define BASE_ID 2
#define ARC_ID 1
#define SUB_BLOCK -5
/* #define gap_open -10 */
#define max3(a,b,c) ((a) >= (b) ? ((a) >= (c) ? (a) : (c)) : ((b) >= (c) ? (b) : (c)))
#define max2(a,b) (a) >= (b) ? (a) : (b)

int base_del, base_mis, base_mat, arc_rem, arc_mat, arc_mis, arc_mismat, arc_bre_mismat, arc_bre_mat, arc_bre_mis, arc_alt_mat, arc_alt_mis,  gap_open;

void get_score(char * score_file,char * nameFileMatrix,int* BASE_MAT, int* BASE_MIS, int* BASE_DEL, int *ARC_MAT, int * ARC_MISMAT, int* ARC_MIS, int* ARC_REM, int* ARC_ALT_MAT, int* ARC_ALT_MIS, int* ARC_BRE_MAT,int* ARC_BRE_MISMAT,  int* ARC_BRE_MIS, int *GAP_OPEN, int USE_MATRIX_SCORE, int ARC, int FULL_EDIT);

void print_score(char * nameFileMatrix, int base_mat, int base_mis, int base_del, int arc_mat, int arc_mismat, int arc_mis, int arc_rem, int arc_alt_mat, int arc_alt_mis, int arc_bre_mat, int arc_bre_mismat, int arc_bre_mis, int gap_open, int USE_MATRIX_SCORE, int ARC, int FULL_EDIT);

void get_matrices(char *input_file);
void free_matrices();
/* score entre deux noeuds */
int substitution(postorder_tree * treeA,postorder_tree * treeB,int i,int j);
int indel(postorder_tree * tree, int i);
int arc_removing(char a, char b); 
int base_mismatch(char a, char b);
int base_deletion(char a);
int arc_mismatch(char a, char b, char c, char d);
int arc_breaking(char a, char b, char c, char d);
int arc_altering1(char a, char b, char c);
int arc_altering2(char a, char b, char c);

#endif /*SCORE_H_*/
