/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#ifndef STACK_H_
#define STACK_H_

/****************************/
/* deux elements            */
/****************************/

typedef struct{
  int x; 
  int y;
}pair;

typedef struct{
  pair * elements; 
  int top;
} stack; 

/*Empile un lment  la pile*/
void push(stack * p, int x,int y);

/*Dpile un lment a la pile*/
void pop(stack * p,int * x,int * y);

/* is the stack empty ? */
int is_empty_stack(stack * p);

/* Memory allocation + initialisation of the stack */
void init_stack(stack * p, int size);


void display_stack(stack * p);

void free_stack(stack *s);

/*********************************/
/*    four elements              */
/*********************************/
 
typedef struct{
  int x; 
  int y;
  int z; 
  int t; 
}quadruplet;

typedef struct{
  quadruplet * elements; 
  int top;
} quadruple_stack; 

/*Empile un lment  la pile*/
void quadruple_push(quadruple_stack * p, int x,int y,int z, int t);

/*Dpile un lment a la pile*/
void quadruple_pop(quadruple_stack * p,int * x,int * y, int * z, int * t);

/* is the stack empty ? */
int is_empty_quadruple_stack(quadruple_stack * p);

/* Memory allocation + initialisation of the stack */
void init_quadruple_stack(quadruple_stack * p, int size);


void display_quadruple_stack(quadruple_stack * p);

void free_quadruple_stack(quadruple_stack *s);

/******************************/
/* five elements              */
/******************************/

typedef struct{
  int x; 
  int y;
  int z; 
  int u;
  int v;
}quintuplet;

typedef struct{
  quintuplet * elements; 
  int top;
} five_stack; 



void five_push(five_stack * p, int x, int y, int z, int u, int v);

int is_empty_five_stack(five_stack * p);

void init_five_stack(five_stack * p, int size);

void five_pop( five_stack * p,int * x,int * y, int *z, int *u, int *v); 


/******************************/
/*  six elements              */
/******************************/

typedef struct{
  int x; 
  int y;
  int z; 
  int u;
  int v;
  int w;
}sextuplet; 

typedef struct{
  sextuplet * elements; 
  int top;
} six_stack; 



void six_push(six_stack * p, int x, int y, int z, int u, int v, int w);

int is_empty_six_stack(six_stack * p);

void init_six_stack(six_stack * p, int size);

void six_pop( six_stack * p,int * x,int * y, int *z, int *u, int *v, int *w); 

void free_six_stack(six_stack *s); 


/******************************/
/*  seven elements              */
/******************************/

typedef struct{
  int x; 
  int y;
  int z; 
  int u;
  int v;
  int w;
  int t;
}sevenuplet; 

typedef struct{
  sevenuplet * elements; 
  int top;
} seven_stack; 



void seven_push(seven_stack * p, int x, int y, int z, int u, int v, int w, int t);

int is_empty_seven_stack(seven_stack * p);

void init_seven_stack(seven_stack * p, int size);

void seven_pop( seven_stack * p,int * x,int * y, int *z, int *u, int *v, int *w, int *t); 

void free_seven_stack(seven_stack *s); 


#endif /*STACK_H_*/
