#!/usr/bin/perl -w

use strict;

my @StrucTab;
my @SeqTab;
my @NameTab;
my @ColorTab;
my @StarTab;
my @parenthTab;
my @eq;
my @taille;
my @stack;
my @res;
my $members = 2;
my $longueur = 0;
my $IN = $ARGV[0];
my $OUT = $ARGV[1];
my @couleur=(' ','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t');
my $alignment_length;

#on charge le fichier en memoire
&lecture_fichier();
#on recherche les "tiges" communes dans l'alignement
&tiges();
#on attribue les couleurs
&attribution_couleur();
#on forme le fichier html
&ecriture();

#charge le fichier forester en memoire
# Quatre tableaux sont crees : 
# seqtab[i][j]  : nucleotide j de la sequence i  
# structab[i][j] : appariement j de la sequence i
#startab : la ligne des etoiles
# nameTab
sub lecture_fichier{
    
    my $name_length=18;
    my $flag = 1;
    my $sequence_num = 0;
    my $structure_num =0;
    my $j1 = 0;
    my $j2 = 0;
    my $j3 = 0;
    my $tmp11 = 0;
    my $tmp21 = 0;
    my $tmp1 = 0;
    my $tmp2 = 0;
    my $ligne;
    my $sequence_name;
    my $i; 
    my $c;
    my $current;
    my $line_num=0;
    my @sequence_position; 
    my @structure_position;
    
    #ouverture du fichier
    open(FORESTER, "< ".$IN) || die "probleme ouverture $!";
    
    $sequence_position[0]=0;
    $sequence_position[1]=0;
    $structure_position[0]=0;
    $structure_position[1]=0;

    #parcours du fichier
    while(<FORESTER>){
	
	#le fichier forester tronque les lignes au bout d'un certains nombre de caracteres:
	#    sequence 1: (....(((...)).
	#    sequence 2: ((....)))(((.
	#    .
	#    .
	#    .
	#
	#si les lignes sont trop longues il met la suite de la meme facon par bloc de sequences
	#    sequence 1: la suite...
	#    sequence 2: la suite..
	#
	#il faut donc memoriser la longueur de chaque ligne


	$current =$_;
	
	if ($line_num==5){	# on a parcouru tout un bloc
	    $sequence_num = 0;
	    $structure_num = 0;
	    $line_num= 0;
	}
	
	else{ #si on se trouve au milieu d'un bloc de sequences
	    $line_num++;
	    
	    if($line_num==5){ # ligne d'etoiles
		print "etoiles \n";
		$ligne=substr($current,18);
		for( $i=0;$i<length($ligne);$i++){
		    $c = substr($ligne, $i, 1);
		    if($c eq ' ' || $c eq '*'){
			$StarTab[$j3]= $c;
			$j3++;
		    }
	       }
	    }
	    else {
		$sequence_name=substr($current,0,18); 
		print "ff ".$line_num." ".$current."\n";
		$ligne=substr($current,18);
	       	
		if($ligne =~ /[gucatACGTU]+/){ # ligne de sequence
		    # on sauvegarde le nom des sequences
		    $NameTab[$sequence_num] = $sequence_name;
		    # on parcourt toute la ligne et on remplit le tableau
		    for( $i=0;$i<length($ligne);$i++){
			$c = substr($ligne, $i, 1);
			if($c eq 'a' || $c eq 'u' || $c eq 'g' || $c eq 'c'|| $c eq '-' || $c eq 'A' || $c eq 'C' || $c eq 'G' || $c eq 'U'){
			    $SeqTab[$sequence_num][$sequence_position[$sequence_num]]= $c;
			    $sequence_position[$sequence_num]++; 
			}
		    }
		    $sequence_num++;
		}
		elsif($ligne =~ /[\(-\)\.]+/){ # ligne de structure
		    for( $i=0;$i<length($ligne);$i++){
			$c = substr($ligne, $i, 1);
			if($c eq '(' || $c eq ')' || $c eq '.' || $c eq '-' || $c eq ' '){
			    $StrucTab[$structure_num][$structure_position[$structure_num]]= $c;
			    $structure_position[$structure_num]++;
			}
		    }
		    $structure_num++;
		}
	    }
	}
    }
    
    
    close(FORESTER);
    $alignment_length=$sequence_position[0];
    print "longueur".$sequence_position[0]."\n";
    print "longueur".$sequence_position[1]."\n";
    print "longueur".$structure_position[0]."\n";
    print "longueur".$structure_position[1]."\n";

}



sub tiges{
    
    #on recherche les couples de parentheses
    for(my $i=0; $i<$members; $i++){
	for(my $j=0; $j<$alignment_length; $j++){
	    #print "$i:$j\n";
	    if($StrucTab[$i][$j] eq '('){
		push(@stack,$j);
	    }
	    if($StrucTab[$i][$j] eq '.'){ 
		$parenthTab[$i][$j] = -1;
	    }
	    if($StrucTab[$i][$j] eq '-'){
		$parenthTab[$i][$j] = -2;
	    }
	    if($StrucTab[$i][$j] eq ')'){
		my $der = pop(@stack);
		$parenthTab[$i][$j] = $der;
		$parenthTab[$i][$der] = $j;
	    }
	}
    }

    for(my $j=0; $j<$alignment_length; $j++){
	$res[$j] = 0;
    }
    
    my @cor;

    for(my $j=0; $j<$alignment_length; $j++){
	$cor[$j] = 0;
    }

    #on recherche les parties communes dans l'alignement
    my $i=0;
    my $coul = 1;
    for(my $j=0; $j<$alignment_length; $j++){
	my $i = 0;
	#on cherche la premiere parenthese fermante de l'alignement pour la colone j
	while($i< $members && $StrucTab[$i][$j] ne ')'){
	   $i++;
	}
	if($i < $members){
	    my $test = 0;
	    while($i<$members && $test == 0){
		if($StrucTab[$i][$j] eq ')'){
		    # on compte le nombre de fermante sur la colone j qui s'ouvrent
		    # sur la meme colone
		    my $ferm = $parenthTab[$i][$j];
		    my $compt = 0;
		    for(my $k=0; $k<$members; $k++){
			if($StrucTab[$k][$j] eq ')' && $parenthTab[$k][$j] == $ferm){
			    $compt++;
			}
		    }
		    # si il y en a plus que le nombre de structures / 2 alors on garde la 
		    # colonne
		    if($compt > $members / 2){
			$cor[$j] = $i;
			$res[$j] = $coul * -1;
			$res[$parenthTab[$i][$j]] = $coul;
			$coul++;
			$test = 1;
		    }
		}
		$i++;
	    }
	}
	if($coul >= 20){
	    $coul = 1;
	}
    }

    #on regroupe les parentheses qui sont "colles"
    for(my $j=0; $j<$alignment_length; $j++){
	if($res[$j] < 0 ){
	    my $k = $j - 1;
	    while($StrucTab[$cor[$k]][$k] eq '-'){
		$k--;
	    }
	    if($res[$k] < 0){
		my $deb = $parenthTab[$cor[$j]][$j];
		my $fin = $parenthTab[$cor[$k]][$k];
		my $test = 0;
		while($deb <= $fin && $test == 0){
		    if($StrucTab[$cor[$deb]][$deb] eq ')'){
			$test = 1;
		    }
		    $deb++;
		}
		if($test == 0){
		    $res[$j] = $res[$k];
		    $res[$parenthTab[$cor[$j]][$j]] = $res[$k] * -1;
		    for(my $i=$parenthTab[$cor[$j]][$j];$i<=$fin;$i++){
			$res[$i] = $res[$k] * -1;
		    }
		    for(my $i=$k+1;$i<$j;$i++){
			$res[$i] = $res[$k];
		    }
		}
	    }	    
	}
    }
  
    # on renumerote les tiges
    my $k = 0;
    my $compt = 1;
    my @test;	
    for(my $j=0; $j<$alignment_length; $j++){
	$test[$j] = 0;
    }
    while($k < $alignment_length){
	if($res[$k] < 0){
	    my $tmp = $res[$k];
	    my $fin = $parenthTab[$cor[$k]][$k];
	    while($k < $alignment_length && $res[$k] == $tmp){
   	 	$res[$k] = $compt * -1;
   	 	if($StrucTab[$cor[$k]][$k] eq ')'){
   	 	    $res[$parenthTab[$cor[$k]][$k]] = $compt;
   	 	}
   	 	$k++;
	    }
	    my $deb = $parenthTab[$cor[$k-1]][$k-1];
	    for(my $i=$deb; $i<$fin;$i++){
		$res[$i] = $compt;
	    }
	    $compt++;
	}
	else{
	    $k++;
	}
    }
   
    for(my $i=0; $i<$members; $i++){
	for(my $j=0; $j<$alignment_length; $j++){
	    $eq[$i][$j] = 0;
	}
    }
    #on adapte le resultat trouv a chaque structure
    for(my $i=0; $i<$members; $i++){
	for(my $j=0; $j<$alignment_length; $j++){
	    if($res[$j] < 0){
		if($StrucTab[$i][$j] eq ')'){
		    if($res[$parenthTab[$i][$j]] == -1*$res[$j]){
			$eq[$i][$j] = $res[$j];
			$eq[$i][$parenthTab[$i][$j]] = $res[$j] * -1;
		    }
		}
		elsif($StrucTab[$i][$j] eq '-'){
		    $eq[$i][$j] = $res[$j];
		}
	    }
	    elsif($res[$j] > 0 && $StrucTab[$i][$j] eq '-'){
		$eq[$i][$j] = $res[$j];
	    }
	}
    }
}


#attribution des couleurs aux differents appariements
sub attribution_couleur{

    my $max;
    my $indice;
    my $test = 0;
    my @temp;

    for(my $i=0;$i<$members;$i++){
	for(my $j=0; $j<$alignment_length;$j++){
	    if($eq[$i][$j] < 0){
		$ColorTab[$i][$j] = $couleur[$eq[$i][$j] * -1 ];
	    }
	    elsif($eq[$i][$j] > 0){
		$ColorTab[$i][$j] = $couleur[$eq[$i][$j]];
	    }
	    else{
		$ColorTab[$i][$j] = $couleur[0];
	    }
	}
    } 
}
 
#ecriture des resultats
sub ecriture{

    my $ligne_forester = 55;
    my $fin=0;
    my $debut = 0;
    my $test = 0;

    open(HTML, ">".$OUT) || die "probleme d'ouverture";

    print HTML "<pre>";
    while($test == 0){

	$debut = $fin;
	if($fin + $ligne_forester < $alignment_length){
	    $fin += $ligne_forester;
	}
	else{
	    $fin = $alignment_length;
	    $test = 1;
	}
	
	print HTML $NameTab[0];
		for(my $j=$debut; $j<$fin;$j++){
	    print HTML "<span class=\"".$ColorTab[0][$j]."\">".$StrucTab[0][$j]."</span>";
	}
	print HTML "\n";
	print HTML $NameTab[0];
	for(my $j=$debut; $j<$fin;$j++){
	    print HTML "<span class=\"".$ColorTab[0][$j]."\">".$SeqTab[0][$j]."</span>";
	}
	print HTML "\n";
	print HTML $NameTab[1];
	for(my $j=$debut; $j<$fin;$j++){
		print HTML "<span class=\"".$ColorTab[1][$j]."\">".$SeqTab[1][$j]."</span>";
	    }
	print HTML "\n";
       	print HTML $NameTab[1];
	for(my $j=$debut; $j<$fin;$j++){
	    print HTML "<span class=\"".$ColorTab[1][$j]."\">".$StrucTab[1][$j]."</span>";
	}
	print HTML "\n";
	print HTML "                  ";
	for(my $j=$debut; $j<$fin;$j++){
	    print HTML "$StarTab[$j]";
	}
	print HTML "\n\n";
    }
    print HTML "</pre>\n";
    close(HTML);
}
