/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "../headers/graph.h"

/*Empile un lment  la pile*/
void push_edge_gap(vertex_gap * v, edge_gap x){
  (v->current_edge)++; 
  v->elements[v->current_edge]=x;
  /* printf ("arc :  -> %d,%d avec un poids egal a %d\n", x.targetX, x.targetY, x.weight);*/
} 

void update_edge_gap(vertex_gap *v, edge_gap x, int * nee){
  int d=0; 
  int is_edge_found=0;
  for (d=0; (d<=v->current_edge) && !is_edge_found; d++){
    if ((v->elements[d].targetX==x.targetX) && (v->elements[d].targetY==x.targetY) && (v->elements[d].table==x.table)){
      is_edge_found=1;
      if  (v->elements[d].weight<x.weight){
	v->elements[d].weight=x.weight;
	v->elements[d].edit_operation=x.edit_operation;
	v->elements[d].origin=x.origin;
	/*	printf ("update arc :  -> %d,%d avec un poids egal a %d\n", x.targetX, x.targetY, x.weight);*/
      }
    }
    
  }
  if (!is_edge_found){
    (*nee)++;
    push_edge_gap(v,x);
  }
}

/*Dpile un lment a la pile*/
void get_edge_gap( vertex_gap * v, edge_gap * x, int d){
   
  *x=v->elements[d]; 
}

/*Teste si la pile est vide*/
int end_of_edge_stack_gap(vertex_gap * v){
  return (v->current_edge==-1);
}

/*Initialise la pile*/
void init_edge_stack_gap(vertex_gap * v, int size){
  if (size>0) v->elements = (edge_gap *)malloc(sizeof(edge_gap)*size);
  v->current_edge=-1;
}

int char_to_int(char c){
  switch (c) {
  case 0 : return 0; 
    break; 
  case 1 : return 1; 
    break; 
  case 2 : return 2; 
    break; 
  case 3 : return 3; 
    break; 
  case 4 : return 4; 
    break; 
  case 5 : return 5; 
    break; 
  case 6 : return 6; 
    break; 
  case 7 : return 7; 
    break; 
  case 8 : return 8; 
    break; 
  default : return 10;
    break;
  }
}


void display_alignment_graph_gap(vertex_gap ** alignment_graph, int k, int l){
  int i,j,d;
  edge_gap ed;

  printf(" 0 : substitution \n");
  printf(" 1 : deletion \n");
  printf(" 2 : arc-breaking sur arbre I \n");
  printf(" 3 : arc-altering sur arbre I avec match en 3' \n");
  printf(" 4 : arc-altering sur arbre I avec match en 5' \n");
  printf(" 5 : insertion \n");
  printf(" 6 : arc-breaking sur arbre II \n");
  printf(" 7 : arc-altering sur arbre II avec match en 3' \n");
  printf(" 8 : arc-altering sur arbre II avec match en 5' \n");
  
  
  for (i=1; i<=k; i++){
    for (j=1; j<=l; j++){
      for (d=0; d<=alignment_graph[i][j].current_edge; d++){
	get_edge_gap(&alignment_graph[i][j], &ed, d);
	printf(" %d, %d [%d] -> %d,%d with weight %d in table %d from %d\n", i,j, char_to_int(ed.edit_operation),
	       ed.targetX ,ed.targetY  ,ed.weight, ed.table, ed.origin);
      }
    }
  }
}


/*Empile un lment  la pile*/
void push_edge(vertex * v, edge x){
  (v->current_edge)++; 
  v->elements[v->current_edge]=x;
}

/*Dpile un lment a la pile*/
void get_edge( vertex * v, edge * x, int d){
  *x=v->elements[d]; 
}

/*Teste si la pile est vide*/
int end_of_edge_stack(vertex * v){
  return (v->current_edge==-1);
}

/*Initialise la pile*/
void init_edge_stack(vertex * v, int size){
  v->elements = (edge *)malloc(sizeof(edge)*size);
  v->current_edge=-1;
}

void update(int w, char eo, edge * ed){
  if (w>ed->weight){
    ed->weight=w; 
    ed->edit_operation=eo;
  }
}


void update_edge(vertex *v, edge x){
  int d=0; 
  int is_edge_found=0;
  for (d=0; (d<=v->current_edge) && !is_edge_found; d++){
    if ((v->elements[d].targetX==x.targetX) && (v->elements[d].targetY==x.targetY)){
      is_edge_found=1;
      if  (v->elements[d].weight<x.weight){
	v->elements[d].weight=x.weight;
	v->elements[d].edit_operation=x.edit_operation;
      }
    }
    
  }
  if (!is_edge_found)
    push_edge(v,x);
}

void display_alignment_graph(vertex ** alignment_graph, int k, int l){
  int i,j,d;
  edge ed;

  printf(" 0 : substitution \n");
  printf(" 1 : deletion \n");
  printf(" 2 : arc-breaking sur arbre I \n");
  printf(" 3 : arc-altering sur arbre I avec match en 3' \n");
  printf(" 4 : arc-altering sur arbre I avec match en 5' \n");
  printf(" 5 : insertion \n");
  printf(" 6 : arc-breaking sur arbre II \n");
  printf(" 7 : arc-altering sur arbre II avec match en 3' \n");
  printf(" 8 : arc-altering sur arbre II avec match en 5' \n");
  
  
  for(i=1; i<=k; i++){
    for(j=1; j<=l; j++){
      for(d=0; d<=alignment_graph[i][j].current_edge; d++){
	get_edge(&alignment_graph[i][j], &ed, d);
	printf(" %d, %d [%d] -> %d,%d with weight %d \n", i,j, 
	       char_to_int(ed.edit_operation),ed.targetX ,ed.targetY  ,ed.weight);
      }
    }
  }
}
