/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include "../headers/RNA_structure.h"

void *mon_free(void *ptr){
  /*printf("free : %04xh\n",(int)ptr);fflush(stdout);*/
  if(ptr != NULL)
    free(ptr);
  return NULL;
}

/*Initialise l'espace mmoire pour une matrice d'entiers*/
int ** new_matrix(postorder_tree * treeA,postorder_tree * treeB){
  int **tab;
  int i;
  
  tab = (int **)malloc(sizeof(int *)*treeA->size);
  for(i=0;i<treeA->size;i++){
    tab[i] = NULL;
    tab[i] = (int *)malloc(sizeof(int)*treeB->size);
  }
  return tab;
}

void free_matrix(int **tab, postorder_tree *tree){
  int i;

  for(i=0;i<tree->size;i++)
    tab[i] = mon_free(tab[i]);
  tab = mon_free(tab);
}

/*Initialise l'espace mmoire pour une matrice de caractres*/
char ** new_matrix_char(postorder_tree * treeA,postorder_tree * treeB){
  char **tab;
  int i;
  tab = (char **)malloc(sizeof(char *)*treeA->size);
  for(i=0;i<treeA->size;i++){
    tab[i] = NULL;
    tab[i] = (char *)malloc (sizeof(char)*treeB->size);
  }
  return tab;
}

void free_matrix_char(char **tab, postorder_tree *tree){
  int i;

  for(i=0;i<tree->size;i++)
    tab[i] = mon_free(tab[i]);
  tab = mon_free(tab);
}

/*Affiche une matrice*/
void display_matrix(postorder_tree * treeA,postorder_tree * treeB,int ** matrix){
  int i,j;
  printf("\t");
  for(i=1;i<treeA->size;i++)
    if(treeA->n[i].labelY>0)printf("  %c-%c\t",treeA->n[i].labelX,treeA->n[i].labelY);
    else printf("  %c  \t",treeA->n[i].labelX);
  printf("\n");
  for(j=1;j<treeB->size;j++){
    if(treeB->n[j].labelY>0)printf("  %c-%c\t",treeB->n[j].labelX,treeB->n[j].labelY);
    else printf("  %c  \t",treeB->n[j].labelX);
    for(i=1;i<treeA->size;i++){
      if(matrix[i][j]==INT_MIN)
	printf("-oo\t");
      else
	printf("%d\t",matrix[i][j]);
    }
    printf("\n");
  }
  printf("\n");
} 


/*Affiche une matrice*/
void display_matrix_char(postorder_tree * treeA,postorder_tree * treeB,char ** matrix){
  int i,j;
  printf("\t");
  for(i=1;i<treeA->size;i++)
    if(treeA->n[i].labelY>0)printf("  %c-%c\t",treeA->n[i].labelX,treeA->n[i].labelY);
    else printf("  %c  \t",treeA->n[i].labelX);
  printf("\n");
  for(j=1;j<treeB->size;j++){
    if(treeB->n[j].labelY>0)printf("  %c-%c\t",treeB->n[j].labelX,treeB->n[j].labelY);
    else printf("  %c  \t",treeB->n[j].labelX);
    for(i=1;i<treeA->size;i++){
      printf("%d\t",matrix[i][j]);
    }
    printf("\n");
  }
  printf("\n");
} 

