/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../headers/stack.h"

/*************************************************/
/* pile de deux entiers                          */
/*************************************************/

/*Empile un lment  la pile*/
void push(stack * p, int x,int y){
  pair element;
  (p->top)++; 
  element.x=x;
  element.y=y;
  p->elements[p->top]=element;
}

/*Dpile un lment a la pile*/
void pop( stack * p,int * x,int * y){
  pair element;
  element=p->elements[p->top];   
  *x=element.x;
  *y=element.y;
  (p->top)--; 
}

/*Test si la pile est vide*/
int is_empty_stack(stack * p){
  return (p->top==-1); 
}

/*Initialise la pile*/
void init_stack(stack * p, int size){
    p->elements = malloc(sizeof(pair)*size);
    p->top=-1;
  
}
 
void display_stack(stack * p){
  pair element; 
  int i=p->top;
  printf("******\n");
  for (i=p->top; i>=0;i--){
    element=p->elements[i]; 
    printf("%d %d \n", element.x, element.y);
  }
  printf("******\n");
}

void free_stack(stack *s){
  free(s->elements);
  free(s);
}

/***********************************************/
/* pile quatre elements                        */
/***********************************************/


/*Empile un lment  la pile*/
void quadruple_push(quadruple_stack * p, int x,int y,int z, int t){
  quadruplet element;
  (p->top)++; 
  element.x=x;
  element.y=y;
  element.z=z;
  element.t=t;
  p->elements[p->top]=element;
 }


/*Dpile un lment a la pile*/
void quadruple_pop( quadruple_stack * p,int * x,int * y, int *z, int *t){
  quadruplet element;
  element=p->elements[p->top];   
  *x=element.x;
  *y=element.y;
  *z=element.z;
  *t=element.t;
  (p->top)--; 
}

/*Test si la pile est vide*/
int is_empty_quadruple_stack(quadruple_stack * p){
  return (p->top==-1); 
}

/*Initialise la pile*/
void init_quadruple_stack(quadruple_stack * p, int size){
    p->elements = malloc(sizeof(quadruplet)*size);
    p->top=-1;
  
}
 
void display_quadruple_stack(quadruple_stack * p){
  quadruplet element; 
  int i=p->top;
  printf("******\n");
  for (i=p->top; i>=0;i--){
    element=p->elements[i]; 
    printf("%d %d %d %d\n", element.x, element.y,element.z, element.t);
  }
  printf("******\n");
}

void free_quadruple_stack(quadruple_stack *s){
  free(s->elements);
  free(s);
}

/*************************************/
/* pile a 5 elements                 */
/*************************************/


void five_push(five_stack * p, int x, int y, int z, int u, int v){
  quintuplet element;
  (p->top)++;
  element.x=x;
  element.y=y;
  element.z=z;
  element.u=u;
  element.v=v;
  p->elements[p->top]=element;
}

/*Test si la pile est vide*/
int is_empty_five_stack(five_stack * p){
  return (p->top==-1); 
}


/*Initialise la pile*/
void init_five_stack(five_stack * p, int size){
    p->elements = malloc(sizeof(quintuplet)*size);
    p->top=-1;
}

/*Dpile un lment a la pile*/
void five_pop( five_stack * p,int * x,int * y, int *z, int *u, int *v){
  quintuplet element;
  element=p->elements[p->top];   
  *x=element.x;
  *y=element.y;
  *z=element.z;
  *u=element.u;
  *v=element.v;
  (p->top)--; 
}


/*************************************/
/*   6-element stack                 */
/*************************************/


void six_push(six_stack * p, int x, int y, int z, int u, int v,int w){
  sextuplet element;
  (p->top)++;
  element.x=x;
  element.y=y;
  element.z=z;
  element.u=u;
  element.v=v;
  element.w=w;
  p->elements[p->top]=element;
}

/*Test si la pile est vide*/
int is_empty_six_stack(six_stack * p){
  return (p->top==-1); 
}


/*Initialise la pile*/
void init_six_stack(six_stack * p, int size){
    p->elements = malloc(sizeof(sextuplet)*size);
    p->top=-1;
}

/*Dpile un lment a la pile*/
void six_pop( six_stack * p,int * x,int * y, int *z, int *u, int *v, int *w){
  sextuplet element;
  element=p->elements[p->top];   
  *x=element.x;
  *y=element.y;
  *z=element.z;
  *u=element.u;
  *v=element.v;
  *w=element.w;
  (p->top)--; 
}

void free_six_stack(six_stack *s){
  free(s->elements);
  free(s);
}



/*************************************/
/*   7-element stack                 */
/*************************************/


void seven_push(seven_stack * p, int x, int y, int z, int u, int v,int w, int t){
  sevenuplet element;
  (p->top)++;
  element.x=x;
  element.y=y;
  element.z=z;
  element.u=u;
  element.v=v;
  element.w=w;
  element.t=t;
  p->elements[p->top]=element;
}

/*Test si la pile est vide*/
int is_empty_seven_stack(seven_stack * p){
  return (p->top==-1); 
}


/*Initialise la pile*/
void init_seven_stack(seven_stack * p, int size){
    p->elements = malloc(sizeof(sevenuplet)*size);
    p->top=-1;
}

/*Dpile un lment a la pile*/
void seven_pop( seven_stack * p,int * x,int * y, int *z, int *u, int *v, int *w, int *t){
  sevenuplet element;
  element=p->elements[p->top];   
  *x=element.x;
  *y=element.y;
  *z=element.z;
  *u=element.u;
  *v=element.v;
  *w=element.w;
  *t=element.t;
  (p->top)--; 
}

void free_seven_stack(seven_stack *s){
  free(s->elements);
  free(s);
}
