/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */


 while ( x+y > i+j ){

    finished = 0;
    /*******************/
    /* implicit edges  */
    /*******************/

    x_old = x; y_old = y;

    if ( (x > i) && (y > j) && (treeA->n[x].size == 1) && (treeB->n[y].size == 1) && 
	 (table[x][y] == base_mismatch_m(treeA->n[x].labelX, treeB->n[y].labelX, treeA->nb_seq, treeB->nb_seq) 
	  + table[x-1][y-1]) ){
      supertree[treeA->n[x].positionX][treeB->n[y].positionX]=1;
      x--; y--; 
      finished = 1;
    }
    else if ( (x > i) && (table[x][y] == table[x-treeA->n[x].size][y] + full_deletionA[x]) ){
      for (d=x; d>x-treeA->n[x].size; d--){
	  supertree[treeA->n[d].positionX][max2(positionB,treeB->n[y].positionY)]=-1;
	  supertree[treeA->n[d].positionY][max2(positionB,treeB->n[y].positionY)]=-1;
      }
      x = x-treeA->n[x].size;
      finished = 1;
    }
    else if ( (y > j) && (table[x][y] == table[x][y-treeB->n[y].size] + full_deletionB[y]) ){
      for (d=y; d>y-treeB->n[y].size; d--){
	  supertree[max2(positionA,treeA->n[x].positionY)][treeB->n[d].positionX]=-2;
	  supertree[max2(positionA,treeA->n[x].positionY)][treeB->n[d].positionY]=-2;
	}
      y = y-treeB->n[y].size; 
      finished = 1;
    }
    
    /*******************/
    /* explicit edges  */
    /*******************/
    for (d=0;  (!finished) && (d <= alignment_graph[x][y].current_edge); d++){
      get_edge(&alignment_graph[x][y], &ed, d);
      if ( (ed.targetX >=i ) && (ed.targetY >= j) && (table[x][y] == ed.weight + get_table(ed.targetX, ed.targetY)) ){
	finished = 1;
	switch (ed.edit_operation) {
	case 0 :  /*  arc_(mis)match */
	  supertree[treeA->n[x].positionX][treeB->n[y].positionX]=1; 
	  supertree[treeA->n[x].positionY][treeB->n[y].positionY]=1; 
	  six_push(p, ed.targetX, ed.targetY, treeA->n[x].positionX, treeB->n[y].positionX, x-1, y-1); 
	  break;
	case 5 :  /* arc_insertion */
	  supertree[max2(positionA,treeA->n[ed.targetX].positionX)][treeB->n[y].positionX]=-2;
	  supertree[treeA->n[x].positionY][treeB->n[y].positionY]=-2;
	  six_push(p, ed.targetX, ed.targetY, max2(positionA,treeA->n[ed.targetX].positionX),  treeB->n[y].positionX, x, y-1);
	  break; 
	case 1 :  /* arc_deletion */ 
	  supertree[treeA->n[x].positionX][max2(positionB,treeB->n[ed.targetY].positionX)]=-1;
	  supertree[treeA->n[x].positionY][treeB->n[y].positionY]=-1;
	  six_push(p, ed.targetX, ed.targetY, treeA->n[x].positionX, max2(positionB,treeB->n[ed.targetY].positionX), x-1, y);
	  break;
	case 6 : /* arc_breaking in B */
	  supertree[treeA->n[ed.targetX+1].positionX][treeB->n[y].positionX]=1;
	  supertree[treeA->n[x].positionX][treeB->n[y].positionY]=1;
	  six_push(p, ed.targetX+1, ed.targetY, treeA->n[ed.targetX+1].positionX,treeB->n[y].positionX,  x-1, y-1); 
	  break;
	case 2 : /* arc_breaking in A */
	  supertree[treeA->n[x].positionX][treeB->n[ed.targetY+1].positionX]=1;
	  supertree[treeA->n[x].positionY][treeB->n[y].positionX]=1;
	  six_push(p, ed.targetX, ed.targetY+1,treeA->n[x].positionX,treeB->n[ed.targetY+1].positionX, x-1, y-1);
	  break;
	case 3 :  /* arc_altering in A with 3' match */
	  supertree[treeA->n[x].positionY][treeB->n[y].positionX]=1;
	  supertree[treeA->n[x].positionX][max2(positionB,treeB->n[ed.targetY].positionX)]=-1;
	  six_push(p, ed.targetX, ed.targetY,treeA->n[x].positionX,max2(positionB,treeB->n[ed.targetY].positionX),  x-1, y-1);
	  break;
	case 7 : /* arc_altering in B with 3' match */
	  supertree[treeA->n[x].positionX][treeB->n[y].positionY]=1;
	  supertree[max2(positionA,treeA->n[ed.targetX].positionX)][treeB->n[y].positionX]=-2;
	  six_push(p, ed.targetX, ed.targetY, max2(positionA,treeA->n[ed.targetX].positionX),treeB->n[y].positionX, x-1, y-1); 
	  break;
	case 4 :  /* arc_altering in A with 5' match */
	  supertree[treeA->n[x].positionX][treeB->n[ed.targetY+1].positionX]=1; 
	  supertree[treeA->n[x].positionY][treeB->n[y].positionY]=-1;
	  six_push(p, ed.targetX, ed.targetY+1,treeA->n[x].positionX,max2(positionB,treeB->n[ed.targetY+1].positionX), x-1, y); 
	  break;
	case 8 : /* arc_altering in B with 5' match */
	  supertree[treeA->n[ed.targetX+1].positionX][treeB->n[y].positionX]=1;
	  supertree[treeA->n[x].positionY][treeB->n[y].positionY]=-2; 
	  six_push(p, ed.targetX+1, ed.targetY,max2(positionA,treeA->n[ed.targetX+1].positionX),treeB->n[y].positionX, x, y-1);
	  break;
	default :
	  printf("error \n");fflush(stdout);
	  break;
	} /* end of switch */
	x = ed.targetX; 
	y = ed.targetY;
      }
    }
    
    if( x_old == x && y_old == y ){
      printf("alignment is not possible \n");
      exit(0);
    }
  }
}
