/* This program is free software: you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation, either version 3 of the License, or */
/* (at your option) any later version. */

/* This program is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with this program.  If not, see <http://www.gnu.org/licenses/>. */


/*----------------------------------------------*/
/* types.c                                      */
/*----------------------------------------------*/

#include "../headers/types.h"

/* secure malloc */
void* sec_malloc (size_t size){
  void* flag=malloc(size);
  if (flag!=NULL) return flag;
  else {printf("\n\n   *** out of memory ***\n\n"); exit(1);
  }
}



/* matrices*/
matrix2_t alloc_matrix2 (int a, int b, int fill){
  matrix2_t mat; 
  int i,j;
  mat = (matrix2_t) sec_malloc((a+1)*sizeof(vector_t));
  mat ++; 
  for (i=-1; i<a; i++){
    mat[i] = (vector_t) sec_malloc((b+1)*sizeof(int)); 
    mat[i] ++;
    for(j=-1; j<b; j++) {
      mat[i][j] = fill;
    }
  } 
  return mat;
}

void free_matrix2 (matrix2_t mat, int a){
  int i;
  
  for (i=-1; i<a; i++) {
    mat[i] --; 
    free(mat[i]);
  } mat--; 
  free(mat);
 

}

void print_matrix2 (matrix2_t mat, int a, int b, int l, int n) {
  int i, j;
  printf ("\n\n     |");
  for (j=MAX(b-l,0);   j<MIN(b+l,n-1); j++) printf ("%4i|", j);
  printf("\n ");
  for (j=MAX(b-l,0)-1; j<MIN(b+l,n-1); j++) printf ("-----");
  printf("\n");
  for (i=MAX(a-l,0); i<MIN(a+l,n-1); i++) {
    printf ("%4i |", i);
    for (j=MAX(b-l,0); j<MIN(b+l,n-1); j++) {
      if (ABS(i-j)<=1) printf ("  - |");
      else if (!mat[i][j]) printf ("    |");
      else printf ("%4i|",-mat[i][j]);}
    printf("\n");}
  printf(" ");
  for (j=MAX(b-l,0)-1; j<MIN(b+l,n-1); j++) printf ("-----");
  printf("\n\n");}


float power (float x, int n){
float p=1; while(n--) p *= x; return p;
}
